#include <stdlib.h>

#ifndef FILENAME_H
#define FILENAME_H

#ifdef  __cplusplus
extern "C" {
#endif
	
#ifndef FILENAME_C
extern int check_sfx(char *filepath, char *sfx);
extern int compare_directory(char *s1, char *s2);
extern int compare_drive(char *s1, char *s2);

extern char *read_filename(char *filepath);
extern char *read_sfx(char *filepath);

extern char *get_directory(char *filepath);
extern char *get_filename(char *filepath);
extern char *get_sfx(char *filepath);
extern char *get_basename(char *filepath);

extern char *change_filename(char *filepath, char *filename);
extern char *change_sfx(char *filepath, char *sfx);

extern int cut_filename(char *filepath);
extern int cut_sfx(char *filepath);

extern int cut_tail_digits(char *string);
extern int cut_tail_underbars(char *string);
extern int cut_tail_path_delimiter(char *string);
extern int cut_tail_separater(char *string);

extern int has_separable_tail_num(char *string);

extern int file_exists(char *filename);
	
#endif

#ifdef  __cplusplus
}
#endif
#endif
